// $Id: DistanceConservative.cc 216 2011-11-27 05:57:39Z peter $

// Copyright (C) 2004, 2005, 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include "DistanceConservative.h"

#include "Distance.h"

#include <algorithm>
#include <vector>

namespace theplu {
namespace speclust {

double DistanceConservative::operator()(const std::vector<double>& l1,
																				const std::vector<double>& l2,
																				double sigma) const
{
	// distance always 1 if at least one peakset is empty.
	if (l1.empty() || l2.empty())
		return 1.0;
	return 1.0 - score(l1,l2,sigma) / std::max(l1.size(), l2.size());
}

}}// end of namespace speclust and namespace theplu
