// $Id: DistanceEuclid.cc 216 2011-11-27 05:57:39Z peter $

// Copyright (C) 2004, 2005, 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include "DistanceEuclid.h"
#include "Distance.h"

#include <vector>

namespace theplu {
namespace speclust {

double DistanceEuclid::operator()(const std::vector<double>& l1,
																	const std::vector<double>& l2,
																	double sigma) const
{
	double distance = l1.size() + l2.size();
	if (l1.size() && l2.size()) {
		distance -= 2*score(l1,l2,sigma);
	}
	return distance;
}

}} // end of namespace and namespace theplu
