#ifndef _theplu_speclust_bin_pic_cluster_
#define _theplu_speclust_bin_pic_cluster_

// $Id: Cluster.h 228 2012-09-13 22:45:17Z peter $

// Copyright (C) 2005 Peter Johansson
// Copyright (C) 2006 Markus Ringnér, Peter Johansson
// Copyright (C) 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include <yat/statistics/Averager.h>
#include <vector>

namespace theplu {
namespace speclust {

  class Peak;
	class Spectrum;

  class Cluster {

  public:
    //
    // Default constructor
    //
    Cluster();

    //
    // Copy Constructor. Not yet implemented.
    //
    Cluster(const Cluster&);

    //
    // adding a peak to the spectrum
    //
    void add(const Peak* p) ;

    inline double min(void) const { return min_; }
    inline double max(void) const { return max_; }
    inline const yat::statistics::Averager& averager(void) const
		{ return averager_; }
		inline const std::vector<const Peak*>& peaks(void) const { return peaks_; }
    inline bool operator<(const Cluster& other) const
      { return averager().mean()<other.averager().mean(); }

    void write_header(std::ostream&, const std::vector<Spectrum*>&) const;

		void write( std::ostream&, const std::vector<Spectrum*>&);

  private:
    double min_;
    double max_;
    yat::statistics::Averager averager_;
    std::vector<const Peak*> peaks_;
  };



}} // end of namespace speclust and namespace theplu

#endif
