#ifndef _theplu_speclust_bin_pic_parameter_
#define _theplu_speclust_bin_pic_parameter_

// $Id: Parameter.h 228 2012-09-13 22:45:17Z peter $

// Copyright (C) 2005, 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include <yat/utility/CommandLine.h>
#include <yat/utility/OptionArg.h>
#include <yat/utility/OptionFile.h>
#include <yat/utility/OptionHelp.h>

#include <string>

// class for command line options.
namespace theplu {
namespace speclust {

class Parameter {

public:
	Parameter(int argc, char *argv[]);

	inline const std::string consensus_file(void) const
	{ return consensus_.value(); }
	inline unsigned int consensus_cutoff(void) const
	{ return consensus_cutoff_.value(); }
	inline const std::string id_file(void) const { return id_.value(); }
	inline const std::string multiple_file(void) const
	{ return multiple_.value(); }
	inline double multiple_cutoff(void) const { return multiple_cutoff_.value();}
	inline const std::string pairwise_file(void) const
	{ return pairwise_.value(); }
	inline double pairwise_cutoff(void) const { return pairwise_cutoff_.value();}
	inline const std::string peakset_file(void) const
	{ return peaksets_.value(); }
	inline double sigma(void) const { return sigma_.value(); }

private:
	theplu::yat::utility::CommandLine cmd_;
	theplu::yat::utility::OptionHelp help_;
	theplu::yat::utility::OptionFile peaksets_;
	theplu::yat::utility::OptionFile id_;
	theplu::yat::utility::OptionArg<double> sigma_;
	theplu::yat::utility::OptionFile consensus_;
	theplu::yat::utility::OptionArg<unsigned int> consensus_cutoff_;
	theplu::yat::utility::OptionFile multiple_;
	theplu::yat::utility::OptionArg<double> multiple_cutoff_;
	theplu::yat::utility::OptionFile pairwise_;
	theplu::yat::utility::OptionArg<double> pairwise_cutoff_;

	// no copy
	Parameter(const Parameter&);	// not implemented
};

}} // end of namespace speclust and namespace theplu

#endif
