#ifndef _theplu_speclust_bin_pic_spectrum_
#define _theplu_speclust_bin_pic_spectrum_

// $Id: Spectrum.h 228 2012-09-13 22:45:17Z peter $

// Copyright (C) 2005, 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include <string>
#include <utility>
#include <iostream>
#include "Peak.h"

namespace theplu {
namespace speclust {

	//	class Peak;

	class Spectrum {

	public:
		//
		// Default constructor
		//
		Spectrum();
		
		//
		// Copy Constructor. Not yet implemented.
		//
		Spectrum(const Spectrum&);

		//
		// Constructor taking name string
		//
		Spectrum(const std::string&);

		//
		// adding a peak to the spectrum
		//
		inline void push_back(Peak* p)
		{ peaks_.push_back(p); mass_.push_back(p->mass());}

		//
		// aligning two spectra and updating the peaks involved
		//
		void align(Spectrum*, const double, const double);

		inline size_t nof_peaks(void) const {return peaks_.size(); }
		inline std::vector<Peak*> peaks(void) const { return peaks_; }
		inline const std::vector<double>& mass(void) const { return mass_;}
		inline const std::string& name(void) const { return name_; }


		
	private:
		const std::string name_;
		std::vector<Peak*> peaks_;
		std::vector<double> mass_;
		
	};
	


}} // end of namespace speclust and namespace theplu

#endif
