#ifndef _theplu_speclust_bin_pic_
#define _theplu_speclust_bin_pic_

// $Id: pic.h 228 2012-09-13 22:45:17Z peter $

// Copyright (C) 2005 Peter Johansson
// Copyright (C) 2006 Markus Ringnér, Peter Johansson
// Copyright (C) 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include "Peak.h"
#include "Spectrum.h"

#include <string>
#include <vector>
#include <iosfwd>

namespace theplu {
	namespace utility { class matrix; }
namespace speclust {

	class Parameter;
	class Spectrum;

	void consensus(const std::vector<Spectrum*>&, const Parameter&);
	void multiple(const std::vector<Spectrum*>&, const Parameter&);
	void pairwise(std::vector<Spectrum*>&, const Parameter&);
	void read_id(std::vector<std::string>&, const std::string&);
	std::istream& operator>>(std::istream&,std::vector<std::vector<double> >&);
	std::ostream& operator<<(std::ostream&,
													 const std::vector<std::vector<double> >&);

	struct SpectrumName
	{
		inline bool operator()(const Peak* a, const Peak* b) const
		{
			return a->spectrum()->name() < b->spectrum()->name();
		}
	};


	struct NameOrder
	{
		inline bool operator()(const Spectrum* a, const Spectrum* b) const
		{
			return a->name() < b->name();
		}
	};

}} // of namespace speclust and namespace theplu

#endif
