#ifndef _theplu_speclust_bin_psm_parameter_
#define _theplu_speclust_bin_psm_parameter_

// $Id: Parameter.h 228 2012-09-13 22:45:17Z peter $

// Copyright (C) 2004 Jari Häkkinen
// Copyright (C) 2005, 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include <string>

// class for command line options.
class Parameter {

public:
	Parameter(const int argc,const char *argv[]);

	inline const std::string& filelist_file(void) const { return filelist_file_; }
	inline unsigned int min_nof_peaks(void) const { return min_nof_peaks_; }
	inline const std::string& new_filelist_file(void) const
		{ return new_filelist_file_; }
	inline const std::string& peakset_file(void) const { return peakset_file_; }

private:
	void analyse(void);
	void defaults(void);
	void help(void);

	std::string filelist_file_;
	unsigned int min_nof_peaks_;
	std::string new_filelist_file_;
	std::string peakset_file_;

	// copy not allowed
	Parameter(const Parameter&);	// not implemented
	Parameter operator=(const Parameter&);
};

#endif
