#ifndef THEP_LU_SPECLUST_DRAW_TREE_H
#define THEP_LU_SPECLUST_DRAW_TREE_H

// $Id: DrawTree.h 228 2012-09-13 22:45:17Z peter $

// Copyright (C) 2002 Carl Troein
// Copyright (C) 2004 Markus Ringnér
// Copyright (C) 2005 Peter Johansson
// Copyright (C) 2006 Markus Ringnér
// Copyright (C) 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include "TreeNode.h"

// Standard C++
#include <vector>
#include <string>

namespace theplu {
namespace speclust {
	using namespace std;
	class DrawTree
	{
	public :
		DrawTree(const vector<TreeNode>&, const vector<string>&);
		~DrawTree(){}
		void make_picture(string filename) const;
	private:
		void draw_scale(double) const;
		void draw_tree(double maxdist, unsigned int node, int &pointsabove,
									 double &xcoord, double &ycoord, double* palette) const;
		void set_color(double* palette, int value) const;
		void leaf_order(const vector<TreeNode>&, int node);

		int maxpoints_;
		vector<TreeNode> nodes_;
		vector<int> leaf_order_;
		vector<string> leaves_;

		int ps_height_;
		int ps_nodewidth_;
	};
}}
#endif
