#ifndef _theplu_speclust_bin_tcg_parameter_
#define _theplu_speclust_bin_tcg_parameter_

// $Id: Parameter.h 228 2012-09-13 22:45:17Z peter $

// Copyright (C) 2004 Markus Ringnér
// Copyright (C) 2005, 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include <string>

// class for command line options.
class Parameter
{
public:
	Parameter(int argc, char *argv[]);

	inline const std::string& distance_file(void) const { return distance_file_; }
	inline const std::string& tree_file(void) const { return tree_file_; }
	inline const std::string& leaf_file(void) const { return leaf_file_; }
	inline const char linkage(void) const { return linkage_; }

private:
	void analyse(const std::string&);

	std::string distance_file_;
	std::string leaf_file_;
	char linkage_;
	std::string tree_file_;

	Parameter(const Parameter&);	// not implemented
};

#endif
