#ifndef _THEP_LU_SPECLUST_TREE_CLUSTER_DISTANCES_H
#define _THEP_LU_SPECLUST_TREE_CLUSTER_DISTANCES_H

// $Id: TreeClusterDistances.h 228 2012-09-13 22:45:17Z peter $

// Copyright (C) 2004 Markus Ringnér
// Copyright (C) 2005 Peter Johansson
// Copyright (C) 2006 Markus Ringnér
// Copyright (C) 2011 Peter Johansson
//
// This file is part of speclust, http://bioinfo.thep.lu.se/speclust.html
//
// Speclust is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 3 of the License, or (at your option) any later
// version.
//
// Speclust is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// speclust. If not, see <http://www.gnu.org/licenses/>.

#include "TreeNode.h"

#include <vector>

namespace theplu {
  namespace yat{
    namespace utility{
      class Matrix;
    }
  }

namespace speclust {


	class TreeClusterDistances
	{
	public:
		TreeClusterDistances(const yat::utility::Matrix&, char);
		void cluster(const yat::utility::Matrix&, char);
		const std::vector<TreeNode>& nodes() const {return nodes_;};
	private:
		std::vector<TreeNode> nodes_;
	};

}}
#endif
